using System.Collections;
using NUnit.Framework;

namespace ValueProviderTests
{
    /// <summary>
    /// Summary description for EntityVPFixture
    /// </summary>
    [TestFixture]
    public class EntityVPFixture
    {
        private const string zipFileResourceName =
            "ValueProviderTests.SampleProjects.SingleProjectSingleClassSingleProperty.zip";
        private const string slnFileName = "SingleProjectSingleClassSingleProperty.sln";
        private const string projectName = "SingleProject";
        
        [Test]
        public void CanFindSingleClass()
        {
            using(EntityValueProviderScaffold scaffold = new EntityValueProviderScaffold(zipFileResourceName, slnFileName, projectName ) )
            {
                ArrayList entities = scaffold.GetEntities();
                GetExpectedEntities().AssertEntitesAreCorrect(entities);
            }
        }
        
        private static ExpectedEntitySet GetExpectedEntities()
        {
            return new ExpectedEntitySet( 
                new ExpectedEntity( "MySingleClass",
                    new ExpectedProperty( "MySingleProperty", typeof(string))));
        }
    }
}
